#!/usr/bin/env python
import serial
from xbee import xbee
import twitter

SERIALPORT = "COM11"    # the com/serial port the XBee is connected to
BAUDRATE = 9600      # the baud rate we talk to the xbee
SENSOR1 = 0			# the AD pin the FSR is connected to (for us 0)
TWEETATS = "@user" # Whoever you want this script to tweet at just seperate multiple with a space
BASELINE = 720 # ADC reading when bowl is empty
THRESHOLD = 770 # ADC reading when contents gets to point where refilling is desired

warningNum = 0 # The number of twitter warnings since last refill level was reached

# Initialize the twitter api. Needs (consumerKey, secret consumerKey, accesskey, secret accesskey)
api = twitter.Api('consumerKey', 'consumerSecret', 'AccessToken', 'Access Token Secret')

#Open communications with recieving XBee
ser = serial.Serial(SERIALPORT, BAUDRATE)
ser.open()

def mainLoop(idleevent):
	global warningNum
	#get packet from xbee
	packet = xbee.find_packet(ser)
	if not packet:
		return
	
	xb = xbee(packet) #parse packet
	
	sensor1data = [-1] * (len(xb.analog_samples) - 1) #initialize an array with negative ones of length of data samples minus one
	for i in range(len(sensor1data)):
		sensor1data[i] = xb.analog_samples[i + 1][SENSOR1]

	sen1avg = 0;
	for i in range(17):#len(sensor1data)):
		sen1avg += sensor1data[i]
	sen1avg = sen1avg / 17 #len(sensor1data)
	
	print "Sensor One Reading: " + str(xb.analog_samples[2][SENSOR1])
	print "Sensor One Avgerage: " + str(sen1avg)
	
	if(sen1avg < THRESHOLD):
		warningNum = warningNum + 1
		status = api.PostUpdate(str(TWEETATS) + " WARNING " + str(warningNum) + ": water is low! You should hurry and fill it up!")
		print "Tweet Sent"
	else:
		warningNum = 0
		
while True:
	mainLoop(None)